"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var Lodash = require("lodash");
var util = require("util");
var BrowserApplication_1 = require("../Core/BrowserApplication");
var BrowserHttpClient_1 = require("../Net/BrowserHttpClient");
var BrowserLarkDate_1 = require("../Utils/BrowserLarkDate");
/**
 * 前端的logger，具备日志上报服务和功能
 */
var BrowserLarkLogger = /** @class */ (function () {
    function BrowserLarkLogger(category) {
        // public constructor() {
        //     // console.log("初始化完成")
        //     window.addEventListener("error", async (...args: any[]) => {
        //         console.log("出错", args)
        //         await mail.send({ title: "出错", body: JSON.stringify(args) })
        //     })
        // }
        this.category = null;
        this.init(category);
    }
    BrowserLarkLogger.prototype.init = function (category) {
        this.setCategory(category);
    };
    BrowserLarkLogger.prototype.setCategory = function (category) {
        this.category = BrowserApplication_1.BrowserApplication.packagePlatform + category;
    };
    BrowserLarkLogger.prototype.log = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.write(args, "LOG  ")];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BrowserLarkLogger.prototype.logIf = function (condition) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.write(args, "LOG  ")];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    BrowserLarkLogger.prototype.trace = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(argv && argv.verbose)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.write(args, "TRACE")];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    BrowserLarkLogger.prototype.fatal = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.write(args, "FATAL")];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BrowserLarkLogger.prototype.info = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.write(args, "INFO ")];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BrowserLarkLogger.prototype.infoIf = function (condition) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.write(args, "INFO ")];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    BrowserLarkLogger.prototype.error = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.write(args, "ERROR")];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BrowserLarkLogger.prototype.errorIf = function (condition) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.write(args, "ERROR")];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    BrowserLarkLogger.prototype.warn = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.write(args, "WARN ")];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    BrowserLarkLogger.prototype.warnIf = function (condition) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.write(args, "WARN ")];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    BrowserLarkLogger.prototype.wrapErrorsWithInspect = function (items) {
        var argvs = [];
        for (var _i = 0, items_1 = items; _i < items_1.length; _i++) {
            var item = items_1[_i];
            argvs.push(this.stringify(item));
        }
        // 格式化输出
        var printf = JSON.stringify(argvs);
        return printf;
    };
    BrowserLarkLogger.prototype.getFormatData = function (log) {
        var logEvent = Lodash.clone(log);
        logEvent.category = this.category;
        logEvent.startTime = new Date();
        logEvent.message = this.wrapErrorsWithInspect(logEvent.message);
        logEvent.level = logEvent.level;
        return logEvent;
    };
    BrowserLarkLogger.prototype.getFormatString = function (log) {
        var logEvent = this.getFormatData(log);
        return BrowserLarkDate_1.BrowserLarkDate.getDateTimeString(logEvent.startTime) + " [" + logEvent.level + "] " + logEvent.category + " - " + logEvent.message;
    };
    BrowserLarkLogger.prototype.write = function (message, level) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var log;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        log = { message: message, level: level, category: this.category };
                        return [4 /*yield*/, BrowserHttpClient_1.BrowserHttpClient.post("/kemao-lark/log/Logger.json", log)];
                    case 1:
                        _a.sent();
                        if (level === "ERROR" || level === "WARN " || level === "FATAL") {
                            console.log("");
                        }
                        console.log(this.getFormatString(log));
                        return [2 /*return*/];
                }
            });
        });
    };
    BrowserLarkLogger.prototype.stringify = function (obj) {
        if ((obj instanceof Error) && obj.stack) {
            return util.inspect(obj);
        }
        if (obj instanceof Date) {
            return BrowserLarkDate_1.BrowserLarkDate.getDateTimeString(new Date());
        }
        if (obj instanceof Buffer) {
            return { type: "Buffer", length: obj.length };
        }
        if (typeof obj === "string") {
            return obj;
        }
        if (Lodash.isObject(obj)) {
            var tmp = {};
            for (var key in obj) {
                if (obj.hasOwnProperty && obj.hasOwnProperty(key)) {
                    var item = obj[key];
                    tmp[key] = this.stringify(item);
                }
            }
            return tmp;
        }
        return obj;
    };
    BrowserLarkLogger.prototype.serializer = function (replacer, cycleReplacer) {
        var _this = this;
        var stack = [];
        var keys = [];
        if (cycleReplacer == null) {
            cycleReplacer = function (key, value) {
                if (stack[0] === value) {
                    return "[Circular ~]";
                }
                return "[Circular ~." + keys.slice(0, stack.indexOf(value)).join(".") + "]";
            };
        }
        return function (key, value) {
            if (stack.length > 0) {
                var thisPos = stack.indexOf(_this);
                // tslint:disable-next-line:no-bitwise
                ~thisPos ? stack.splice(thisPos + 1) : stack.push(_this);
                // tslint:disable-next-line:no-bitwise
                ~thisPos ? keys.splice(thisPos, Infinity, key) : keys.push(key);
                // tslint:disable-next-line:no-bitwise
                if (~stack.indexOf(value)) {
                    value = cycleReplacer.call(_this, key, value);
                }
            }
            else {
                stack.push(value);
            }
            return replacer == null ? value : replacer.call(_this, key, value);
        };
    };
    return BrowserLarkLogger;
}());
exports.BrowserLarkLogger = BrowserLarkLogger;
exports.browserLogger = new BrowserLarkLogger("Log/LarkLogger");
//# sourceMappingURL=BrowserLarkLogger.js.map