"use strict";
exports.__esModule = true;
var Lodash = require("lodash");
var BrowserLarkArray_1 = require("./BrowserLarkArray");
exports.UNDEFINED = "undefined";
var BrowserLarkObject = /** @class */ (function () {
    function BrowserLarkObject() {
    }
    BrowserLarkObject.isUndefined = function (obj) {
        return typeof obj === exports.UNDEFINED;
    };
    BrowserLarkObject.isNull = function (obj) {
        return obj === null;
    };
    BrowserLarkObject.isNullOrIsUndefined = function (obj) {
        return BrowserLarkObject.isUndefined(obj) || BrowserLarkObject.isNull(obj);
    };
    /**
     * 对一个js对象进行深度排序，按其名称字母
     * @param obj
     */
    BrowserLarkObject.sort = function (obj) {
        if (obj instanceof Array) {
            return obj;
        }
        var newObj = {};
        var keys = Object.keys(obj);
        keys = keys.sort();
        keys.map(function (key) {
            if (obj[key] instanceof Object && (typeof obj[key] === "function") === false) {
                newObj[key] = BrowserLarkObject.sort(obj[key]);
            }
            else {
                newObj[key] = obj[key];
            }
        });
        return newObj;
    };
    /**
     * 合并两个对象，并进行深层重复值去重
     * @param obj
     */
    BrowserLarkObject.merge = function (obj, option) {
        if (option === void 0) { option = { clean: true, concatArray: true }; }
        var defaultOption = {
            clean: true, concatArray: true
        };
        option = Object.assign(defaultOption, option);
        var data = Lodash.mergeWith(obj.from, obj.to, option.concatArray ? function (objValue, srcValue) {
            if (objValue instanceof Array) {
                var arr = Lodash.union(objValue.concat(srcValue));
                return arr;
            }
        } : null);
        if (option.clean) {
            data = BrowserLarkObject.cleanObjectData(data);
        }
        return data;
    };
    /**
     * 清除对象里面的无用数据
     * @param obj
     */
    BrowserLarkObject.cleanObjectData = function (obj) {
        for (var i in obj) {
            if (obj.hasOwnProperty(i)) {
                if (obj[i] instanceof Array) {
                    obj[i] = BrowserLarkArray_1.BrowserLarkArray.cleanArrayNull(obj[i]);
                }
                else if (typeof obj[i] === "object") {
                    obj[i] = BrowserLarkObject.cleanObjectData(obj[i]);
                }
            }
        }
        return obj;
    };
    return BrowserLarkObject;
}());
exports.BrowserLarkObject = BrowserLarkObject;
//# sourceMappingURL=BrowserLarkObject.js.map