"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var React = require("react");
var ReactDom = require("react-dom");
/**
 * 用于简化react的一些方法使用
 * 临时的，到时换成lark的
 */
var BrowserLarkReact = /** @class */ (function () {
    function BrowserLarkReact(component) {
        if (component === void 0) { component = null; }
        this.component = null;
        this.process = false;
        this.component = component;
    }
    /**
     * 创建一个容器，并将组件渲染到容器内
     */
    BrowserLarkReact.render = function (component, props, children) {
        if (props === void 0) { props = {}; }
        if (children === void 0) { children = null; }
        this.renderElement(React.createElement(component, props, children));
    };
    BrowserLarkReact.renderElement = function (element) {
        var container = document.createElement("div");
        document.body.appendChild(container);
        ReactDom.render(element, container);
    };
    BrowserLarkReact.getClassName = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return argv.join(" ");
    };
    BrowserLarkReact.prototype.isProcess = function () {
        return this.process;
    };
    BrowserLarkReact.prototype.processing = function (handle, onStart, onEnd) {
        var _this = this;
        if (onStart === void 0) { onStart = function () { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
            return [2 /*return*/];
        }); }); }; }
        if (onEnd === void 0) { onEnd = function () { return tslib_1.__awaiter(_this, void 0, void 0, function () { return tslib_1.__generator(this, function (_a) {
            return [2 /*return*/];
        }); }); }; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                        var error_1;
                        return tslib_1.__generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!(this.process === false)) return [3 /*break*/, 8];
                                    // console.log("start");
                                    this.process = true;
                                    return [4 /*yield*/, onStart()];
                                case 1:
                                    _a.sent();
                                    _a.label = 2;
                                case 2:
                                    _a.trys.push([2, 4, 5, 7]);
                                    return [4 /*yield*/, handle()];
                                case 3:
                                    _a.sent();
                                    return [3 /*break*/, 7];
                                case 4:
                                    error_1 = _a.sent();
                                    reject(error_1);
                                    return [3 /*break*/, 7];
                                case 5:
                                    this.process = false;
                                    return [4 /*yield*/, onEnd()];
                                case 6:
                                    _a.sent();
                                    return [7 /*endfinally*/];
                                case 7:
                                    resolve();
                                    return [3 /*break*/, 9];
                                case 8:
                                    console.warn("被丢弃的事件");
                                    _a.label = 9;
                                case 9: return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    BrowserLarkReact.prototype.setState = function (state) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        if (_this.component !== null) {
                            _this.component.setState(state, function () {
                                resolve();
                            });
                        }
                        else {
                            reject(new Error("组件未初始化"));
                        }
                    })];
            });
        });
    };
    BrowserLarkReact.prototype.forceUpdate = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _this = this;
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.component.forceUpdate(function () {
                            console.log("forceUpdate");
                            resolve();
                        });
                    })];
            });
        });
    };
    return BrowserLarkReact;
}());
exports.BrowserLarkReact = BrowserLarkReact;
//# sourceMappingURL=BrowserLarkReact.js.map