"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var LarkLoggerWeb_1 = require("../Log/Logger/LarkLoggerWeb");
var MailWeb_1 = require("../Notice/Mail/MailWeb");
var LarkSequenceWeb_1 = require("../Utils/LarkSequence/LarkSequenceWeb");
var WebRouter_1 = require("../Web/WebRouter");
var NSQWeb_1 = require("../NSQ/NSQWeb");
var ReactPageController_1 = require("../Web/Controller/PageController/ReactPageController");
var WebServer_1 = require("../Web/WebServer");
var LarkPageController = /** @class */ (function (_super) {
    tslib_1.__extends(LarkPageController, _super);
    function LarkPageController() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LarkPageController.prototype.getIndexPageAction = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.setTitle("Lark控制台");
                this.addScript("bootstrap");
                this.render();
                return [2 /*return*/];
            });
        });
    };
    LarkPageController.prototype.getTestPageAction = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var js;
            return tslib_1.__generator(this, function (_a) {
                this.setTitle("test page:" + this.request.path);
                js = this.request.path.replace("/", "").replace(".html", "");
                this.addScript(js);
                this.render();
                return [2 /*return*/];
            });
        });
    };
    return LarkPageController;
}(ReactPageController_1.ReactPageController));
exports.LarkPageController = LarkPageController;
var LarkPageRouter = /** @class */ (function (_super) {
    tslib_1.__extends(LarkPageRouter, _super);
    function LarkPageRouter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LarkPageRouter.prototype.bindRouter = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.router.get("/", this.asyncAction.bind(this, LarkPageController, "getIndexPageAction"));
                this.router.get("/test*", this.asyncAction.bind(this, LarkPageController, "getTestPageAction"));
                return [2 /*return*/];
            });
        });
    };
    return LarkPageRouter;
}(WebRouter_1.WebRouter));
exports.LarkPageRouter = LarkPageRouter;
var LarkWebRouter = /** @class */ (function (_super) {
    tslib_1.__extends(LarkWebRouter, _super);
    function LarkWebRouter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LarkWebRouter.prototype.bindRouter = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.router.use("/", new LarkPageRouter().getRouter());
                this.router.use("/", new LarkSequenceWeb_1.LarkSequenceRouter().getRouter());
                this.router.use("/", new LarkPageRouter().getRouter());
                this.router.use("/", new LarkLoggerWeb_1.LarkLoggerRouter().getRouter());
                this.router.use("/", new MailWeb_1.MailRouter().getRouter());
                this.router.use("/", new NSQWeb_1.NSQRouter().getRouter());
                return [2 /*return*/];
            });
        });
    };
    return LarkWebRouter;
}(WebRouter_1.WebRouter));
exports.LarkWebRouter = LarkWebRouter;
var LarkWebServer = /** @class */ (function () {
    function LarkWebServer() {
    }
    LarkWebServer.prototype.bootstrap = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, new WebServer_1.WebServer()
                            .setRouter(new LarkWebRouter())
                            .bootstrap()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return LarkWebServer;
}());
exports.LarkWebServer = LarkWebServer;
//# sourceMappingURL=LarkWeb.js.map