"use strict";
exports.__esModule = true;
var LarkError = /** @class */ (function () {
    /**
     * 错误
     * @param name 错误的字符串枚举，全大写加下划线开头，全局不重复
     * @param code 不重复的错误码
     * @param message 简短的对错误的信息进行描述
     */
    function LarkError(message, data, code, name) {
        if (message === void 0) { message = ""; }
        if (data === void 0) { data = null; }
        if (code === void 0) { code = -1; }
        if (name === void 0) { name = "LarkError"; }
        this.code = -1;
        this.data = null;
        this.stack = null;
        // super(message)
        this.name = name;
        this.code = code;
        this.data = data;
        var stack = new Error().stack.replace(/\ \ \ \ /g, "").split("\n");
        stack.shift();
        this.stack = stack;
    }
    LarkError.prototype["throw"] = function () {
        throw this;
    };
    return LarkError;
}());
exports.LarkError = LarkError;
//# sourceMappingURL=LarkError.js.map