"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var fs = require("fs-extra");
var os = require("os");
var util = require("util");
var yargs_1 = require("yargs");
var LarkDate_1 = require("../../Utils/LarkDate");
var LoggerDto_1 = require("./LoggerDto");
var LarkString_1 = require("../../Utils/LarkString");
var slog = require('single-line-log').stdout;
var LarkLogger = /** @class */ (function () {
    function LarkLogger(category) {
        if (category === void 0) { category = "default"; }
        this.category = "default";
        this.category = category;
    }
    LarkLogger.prototype.percent = function (title, index, total, message) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var log, p, pIndex, percent;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        log = [title];
                        p = Math.floor((index / total) * 100);
                        pIndex = Math.floor(p);
                        percent = "\u3010" + LarkString_1.LarkString.pad(pIndex, "#") + LarkString_1.LarkString.pad(100 - pIndex, "-") + "\u3011";
                        log.push(percent);
                        log.push(p + "%");
                        log.push(index + "/" + total);
                        log.push(message);
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.INFO, log)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.log = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.LOG, argv)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.warn = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // console.log()
                    return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.WARN, argv)];
                    case 1:
                        // console.log()
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.info = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.INFO, argv)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.error = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // console.log()
                    return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.ERROR, argv)];
                    case 1:
                        // console.log()
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.fatal = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // console.log()
                    return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.FATAL, argv)];
                    case 1:
                        // console.log()
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.trace = function () {
        var argv = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argv[_i] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!yargs_1.argv.verbose) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.TRACE, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.infoIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.INFO, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.errorIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.ERROR, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.warnIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.WARN, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.logIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.LOG, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.debugIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!condition) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.DEBUG, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.traceIf = function (condition) {
        var argv = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            argv[_i - 1] = arguments[_i];
        }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!yargs_1.argv.verbose) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.output(LoggerDto_1.LOGGER_LEVEL.TRACE, argv)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.report = function (log) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // 分配id
                    // 打印输出
                    return [4 /*yield*/, this.print(log)];
                    case 1:
                        // 分配id
                        // 打印输出
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.prototype.print = function (log) {
        var content = LarkDate_1.LarkDate.format(new Date(), "yyyy-MM-dd hh:mm:ss.uuu") + " [" + LoggerDto_1.LOGGER_LEVEL[log.level].toUpperCase() + "]\t" + this.category + " - " + log.message + " " + log.data.join(" ").replace(/\\n|\"/g, "");
        switch (log.level) {
            case LoggerDto_1.LOGGER_LEVEL.INFO:
                slog("" + LoggerDto_1.ILoggerColor.FgGreen + content + LoggerDto_1.ILoggerColor.Reset);
                break;
            case LoggerDto_1.LOGGER_LEVEL.ERROR:
                console.error("" + LoggerDto_1.ILoggerColor.FgRed + content + LoggerDto_1.ILoggerColor.Reset);
                break;
            case LoggerDto_1.LOGGER_LEVEL.WARN:
                console.warn("" + LoggerDto_1.ILoggerColor.FgYellow + content + LoggerDto_1.ILoggerColor.Reset);
                break;
            case LoggerDto_1.LOGGER_LEVEL.FATAL:
                console.error("" + LoggerDto_1.ILoggerColor.FgWhite + LoggerDto_1.ILoggerColor.BgRed + content + LoggerDto_1.ILoggerColor.Reset);
                break;
            default:
                console.log(content);
        }
    };
    LarkLogger.prototype.output = function (level, argv) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var s;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        s = LarkLogger.getStringify(argv);
                        return [4 /*yield*/, this.report({
                                level: level,
                                data: s.data,
                                message: s.message,
                                category: this.category,
                                createDatetime: new Date(),
                                platform: LoggerDto_1.PLATFORM.SERVER
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    LarkLogger.getStringify = function (data) {
        var m = "";
        if (typeof data[0] === "string") {
            m = data.shift();
        }
        var tmp = [];
        for (var _i = 0, data_1 = data; _i < data_1.length; _i++) {
            var item = data_1[_i];
            var message = null;
            if (item instanceof Date) {
                message = item.toString();
            }
            else if (item instanceof Buffer) {
                message = { type: "buffer", length: message.length };
            }
            else if (typeof item === "object") {
                message = JSON.stringify(util.inspect(item));
            }
            else {
                message = JSON.stringify(item);
            }
            tmp.push(message);
        }
        var a = {
            message: m,
            data: tmp
        };
        return a;
    };
    LarkLogger.prototype.writeFileLog = function (info) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var file;
            return tslib_1.__generator(this, function (_a) {
                file = os.tmpdir() + "/nodejs." + LarkDate_1.LarkDate.format(new Date(), "yyyy-MM-dd") + ".log";
                fs.appendFile(file, info + "\n");
                return [2 /*return*/];
            });
        });
    };
    return LarkLogger;
}());
exports.LarkLogger = LarkLogger;
exports.logger = new LarkLogger();
//# sourceMappingURL=LarkLogger.js.map