"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var Controller_1 = require("../../Web/Controller");
var WebRouter_1 = require("../../Web/WebRouter");
var HttpClient_1 = require("../../Net/HttpClient");
var LarkLoggerRouter = /** @class */ (function (_super) {
    tslib_1.__extends(LarkLoggerRouter, _super);
    function LarkLoggerRouter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LarkLoggerRouter.prototype.bindRouter = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.router.post("/Log/Logger/report.json", this.asyncAction.bind(this, LarkLoggerController, "postAction"));
                return [2 /*return*/];
            });
        });
    };
    return LarkLoggerRouter;
}(WebRouter_1.WebRouter));
exports.LarkLoggerRouter = LarkLoggerRouter;
var LarkLoggerController = /** @class */ (function (_super) {
    tslib_1.__extends(LarkLoggerController, _super);
    function LarkLoggerController() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * 存储日志，如果是致命错误，则发送邮件报警
     */
    LarkLoggerController.prototype.postAction = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var log;
            return tslib_1.__generator(this, function (_a) {
                log = this.getPost("log");
                log.createDatetime = new Date(log.createDatetime);
                // const info = { ok: true, id, category: log.category, message: log.message, datetime: LarkDate.format(new Date()) }
                // console.log("LoggerController", JSON.stringify(info))
                this.sendJSON({ ok: true });
                return [2 /*return*/];
            });
        });
    };
    return LarkLoggerController;
}(Controller_1.Controller));
exports.LarkLoggerController = LarkLoggerController;
var LarkLoggerWebAPI = /** @class */ (function () {
    function LarkLoggerWebAPI() {
    }
    LarkLoggerWebAPI.log = function (log) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, HttpClient_1.HttpClient.postLocalServer("/Log/Logger/report.json", { log: log })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return LarkLoggerWebAPI;
}());
exports.LarkLoggerWebAPI = LarkLoggerWebAPI;
//# sourceMappingURL=LarkLoggerWeb.js.map