"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var MongoDatabase_1 = require("../../Storage/MongoDatabase/MongoDatabase");
var LarkLogger_1 = require("./LarkLogger");
var LoggerDB = /** @class */ (function (_super) {
    tslib_1.__extends(LoggerDB, _super);
    function LoggerDB() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LoggerDB.prototype.save = function (log) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var _a, collection;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = log;
                        return [4 /*yield*/, MongoDatabase_1.MongoDatabase.getSequence("Logs", "LarkDB")];
                    case 1:
                        _a.id = _b.sent();
                        return [4 /*yield*/, MongoDatabase_1.MongoDatabase.getCollection("LarkDB", "Logs")];
                    case 2:
                        collection = _b.sent();
                        return [4 /*yield*/, collection.insertOne(log)];
                    case 3:
                        _b.sent();
                        return [2 /*return*/, log.id];
                }
            });
        });
    };
    LoggerDB.prototype.report = function (log) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var task, uuid;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        task = this.save(log);
                        uuid = MongoDatabase_1.MongoDatabase.pushTask(task);
                        this.print(log);
                        return [4 /*yield*/, task];
                    case 1:
                        _a.sent();
                        MongoDatabase_1.MongoDatabase.removeTask(uuid);
                        return [2 /*return*/];
                }
            });
        });
    };
    return LoggerDB;
}(LarkLogger_1.LarkLogger));
exports.LoggerDB = LoggerDB;
exports.loggerDB = new LoggerDB();
//# sourceMappingURL=LoggerDB.js.map