"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var index_1 = require("../index");
var index_2 = require("./index");
var logger = new index_1.LarkLogger("NSQ/NSQ");
var NSQ = /** @class */ (function () {
    function NSQ() {
    }
    NSQ.getNSQ = function (topic) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var collection, record, response;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger.log("getNSQ", { topic: topic });
                        return [4 /*yield*/, index_1.MongoDatabase.getCollection("LarkDB", "Topic")];
                    case 1:
                        collection = _a.sent();
                        return [4 /*yield*/, collection.findOneAndUpdate({
                                topic: topic,
                                status: index_2.NSQ_STATUS.READY,
                                packageName: index_1.Application.getPackageName(),
                                createDatetime: {
                                    $lt: new Date()
                                }
                            }, {
                                $set: {
                                    status: index_2.NSQ_STATUS.PENDING
                                }
                            }, {
                                sort: {
                                    weight: 1
                                }
                            })];
                    case 2:
                        record = _a.sent();
                        response = {
                            ok: true,
                            record: null
                        };
                        response.record = record.value;
                        if (!(record.value === null)) return [3 /*break*/, 4];
                        return [4 /*yield*/, collection.findOneAndUpdate({
                                topic: topic,
                                status: index_2.NSQ_STATUS.PENDING,
                                packageName: index_1.Application.getPackageName(),
                                createDatetime: {
                                    $lt: new Date(new Date().getTime() + 60 * 1000)
                                }
                            }, {
                                $set: {
                                    updateDatetime: new Date()
                                }
                            }, {
                                sort: {
                                    weight: 1
                                }
                            })];
                    case 3:
                        record = _a.sent();
                        response.record = record.value;
                        _a.label = 4;
                    case 4: return [2 /*return*/, response];
                }
            });
        });
    };
    NSQ.updateStatus = function (id, status) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var collection;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, index_1.MongoDatabase.getCollection("LarkDB", "Topic")];
                    case 1:
                        collection = _a.sent();
                        logger.log("updateStatusAction", { id: id }, { $set: { status: status } });
                        return [4 /*yield*/, collection.updateOne({ id: id }, {
                                $set: {
                                    status: status,
                                    updateDatetime: new Date()
                                }
                            })];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, ({ ok: true })];
                }
            });
        });
    };
    NSQ.addNSQ = function (topic, message, createDatetime, weight) {
        if (createDatetime === void 0) { createDatetime = new Date(); }
        if (weight === void 0) { weight = 0; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var collection, record, _a;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, index_1.MongoDatabase.getCollection("LarkDB", "Topic")];
                    case 1:
                        collection = _b.sent();
                        if (createDatetime === null) {
                            createDatetime = new Date();
                        }
                        _a = {};
                        return [4 /*yield*/, index_1.MongoDatabase.getSequence("Topic", "LarkDB")];
                    case 2:
                        record = (_a.id = _b.sent(),
                            _a.topic = topic,
                            _a.message = message,
                            _a.status = index_2.NSQ_STATUS.READY,
                            _a.createDatetime = createDatetime,
                            _a.packageName = index_1.Application.getPackageName(),
                            _a.version = index_1.Application.getVersion(),
                            _a.weight = weight,
                            _a);
                        logger.info("addNSQ", record);
                        return [4 /*yield*/, collection.insertOne(record)];
                    case 3:
                        _b.sent();
                        return [2 /*return*/, record];
                }
            });
        });
    };
    return NSQ;
}());
exports.NSQ = NSQ;
//# sourceMappingURL=NSQ.js.map