"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var WebRouter_1 = require("../Web/WebRouter");
var NSQDto_1 = require("./NSQDto");
var Controller_1 = require("../Web/Controller");
var MongoDatabase_1 = require("../Storage/MongoDatabase/MongoDatabase");
var index_1 = require("../index");
var index_2 = require("../../index");
var NSQController = /** @class */ (function (_super) {
    tslib_1.__extends(NSQController, _super);
    function NSQController() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * post:{message:string,topic}
     */
    NSQController.prototype.addAction = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var topic, message, createDatetimeString, createDatetime, collection, record, _a;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        topic = this.getPost("topic") // string
                        ;
                        message = this.getPost("message") // any
                        ;
                        createDatetimeString = this.getPost("createDatetime") // string
                        ;
                        createDatetime = null;
                        console.log("post.raw", { createDatetimeString: createDatetimeString });
                        if (createDatetimeString === null) {
                            createDatetime = new Date();
                        }
                        else {
                            createDatetime = new Date(createDatetimeString);
                            if (isNaN(createDatetime.getTime())) {
                                throw new index_1.LarkError("createDatetime不是时间格式", { createDatetime: createDatetime });
                            }
                        }
                        console.log("post.after", { createDatetime: createDatetime });
                        return [4 /*yield*/, MongoDatabase_1.MongoDatabase.getCollection("LarkDB", "Topic")];
                    case 1:
                        collection = _b.sent();
                        _a = {};
                        return [4 /*yield*/, MongoDatabase_1.MongoDatabase.getSequence("Topic", "LarkDB")];
                    case 2:
                        record = (_a.id = _b.sent(),
                            _a.topic = topic,
                            _a.message = message,
                            _a.status = NSQDto_1.NSQ_STATUS.READY,
                            _a.createDatetime = createDatetime,
                            _a.version = index_2.Application.getVersion(),
                            _a);
                        return [4 /*yield*/, collection.insertOne(record)];
                    case 3:
                        _b.sent();
                        this.sendJSON({ ok: true });
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 更新任务
     * id
     * status
     */
    NSQController.prototype.updateStatusAction = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var id, status, collection;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        id = Number(this.getPost("id"));
                        status = Number(this.getPost("status"));
                        return [4 /*yield*/, MongoDatabase_1.MongoDatabase.getCollection("LarkDB", "Topic")];
                    case 1:
                        collection = _a.sent();
                        console.log("updateStatusAction", { id: id }, { $set: { status: status } });
                        return [4 /*yield*/, collection.updateOne({ id: id }, {
                                $set: {
                                    status: status,
                                    updateDatetime: new Date()
                                }
                            })];
                    case 2:
                        _a.sent();
                        this.sendJSON({ ok: true });
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 分发任务
     * 状态为Ready的任务
     * 状态为Pending的任务，但是超过10分钟仍然没有处理完的。优先处理完所有Ready任务
     */
    NSQController.prototype.getNSQAction = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var topic, collection, record, response;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        topic = this.getPost("topic");
                        console.log("getNSQAction", { topic: topic });
                        return [4 /*yield*/, MongoDatabase_1.MongoDatabase.getCollection("LarkDB", "Topic")];
                    case 1:
                        collection = _a.sent();
                        return [4 /*yield*/, collection.findOneAndUpdate({
                                topic: topic,
                                status: NSQDto_1.NSQ_STATUS.READY,
                                createDatetime: {
                                    $lt: new Date()
                                }
                            }, {
                                $set: {
                                    status: NSQDto_1.NSQ_STATUS.PENDING
                                }
                            })];
                    case 2:
                        record = _a.sent();
                        response = {
                            ok: true,
                            record: null
                        };
                        response.record = record.value;
                        if (!(record.value === null)) return [3 /*break*/, 4];
                        return [4 /*yield*/, collection.findOneAndUpdate({
                                topic: topic,
                                status: NSQDto_1.NSQ_STATUS.PENDING,
                                createDatetime: {
                                    $lt: new Date(new Date().getTime() + 60 * 1000)
                                }
                            }, {
                                $set: {
                                    updateDatetime: new Date()
                                }
                            })
                            // logger.log("处理超时任务", record)
                        ];
                    case 3:
                        // logger.warn("处理超时任务")
                        record = _a.sent();
                        // logger.log("处理超时任务", record)
                        response.record = record.value;
                        _a.label = 4;
                    case 4:
                        this.sendJSON(response);
                        return [2 /*return*/];
                }
            });
        });
    };
    return NSQController;
}(Controller_1.Controller));
exports.NSQController = NSQController;
var NSQRouter = /** @class */ (function (_super) {
    tslib_1.__extends(NSQRouter, _super);
    function NSQRouter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NSQRouter.prototype.bindRouter = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                /**
                 * 创建topic
                 */
                this.router.post("/NSQ/Topic/add.json", this.asyncAction.bind(this, NSQController, "addAction"));
                /**
                 * 更新状态
                 */
                this.router.post("/NSQ/Topic/updateStatus.json", this.asyncAction.bind(this, NSQController, "updateStatusAction"));
                /**
                 * 获取消息
                 */
                this.router.post("/NSQ/Topic/getNSQ.json", this.asyncAction.bind(this, NSQController, "getNSQAction"));
                return [2 /*return*/];
            });
        });
    };
    return NSQRouter;
}(WebRouter_1.WebRouter));
exports.NSQRouter = NSQRouter;
var NSQWebAPI = /** @class */ (function () {
    function NSQWebAPI() {
    }
    return NSQWebAPI;
}());
//# sourceMappingURL=NSQWeb.js.map