"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var Path = require("path");
var Controller_1 = require("../../Web/Controller");
var HttpClient_1 = require("../HttpClient");
var HttpClientController = /** @class */ (function (_super) {
    tslib_1.__extends(HttpClientController, _super);
    function HttpClientController() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HttpClientController.prototype.getAction = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var url, urlInfo, response;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.request.query.url;
                        urlInfo = Path.parse(url);
                        return [4 /*yield*/, HttpClient_1.HttpClient.get(url)];
                    case 1:
                        response = _a.sent();
                        this.setContentType(urlInfo.ext);
                        this.sendBuffer(response);
                        return [2 /*return*/];
                }
            });
        });
    };
    HttpClientController.prototype.getJSONAction = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var url, options, response, json;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.request.query.url;
                        options = JSON.parse(this.request.query.options);
                        if (!options.proxyOptions.text) return [3 /*break*/, 2];
                        return [4 /*yield*/, HttpClient_1.HttpClient.get(url, options.proxyOptions)];
                    case 1:
                        response = _a.sent();
                        this.sendJSON({
                            text: response.toString("utf8")
                        });
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, HttpClient_1.HttpClient.getJSON(url)];
                    case 3:
                        json = _a.sent();
                        this.sendJSON(json);
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return HttpClientController;
}(Controller_1.Controller));
exports.HttpClientController = HttpClientController;
var HttpClientWebAPI = /** @class */ (function () {
    function HttpClientWebAPI() {
    }
    return HttpClientWebAPI;
}());
//# sourceMappingURL=HttpClientWeb.js.map