"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var nodemailer = require("nodemailer");
var LarkLogger_1 = require("../Log/Logger/LarkLogger");
var MongoDatabase_1 = require("../Storage/MongoDatabase/MongoDatabase");
var MailDto_1 = require("./Mail/MailDto");
var Mail = /** @class */ (function () {
    function Mail() {
    }
    /**
     *
     * @param title 邮件标题
     * @param body 标题内容
     * @param httpProxy 是否走http代理
     */
    Mail.send = function (title, body) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var logger, mailBody, larkDB, mailCollection, index, _a, i, sender, mailOptions, info, error_1;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        logger = new LarkLogger_1.LarkLogger("Notice/Mail");
                        mailBody = {
                            title: title,
                            body: body
                        };
                        return [4 /*yield*/, MongoDatabase_1.MongoDatabase.getDB("LarkDB")];
                    case 1:
                        larkDB = _b.sent();
                        mailCollection = larkDB.collection("Mail");
                        index = 0;
                        if (typeof mailBody.body !== "string") {
                            mailBody.body = mailBody.title;
                        }
                        _a = mailBody;
                        return [4 /*yield*/, MongoDatabase_1.MongoDatabase.getSequence("Mail")];
                    case 2:
                        _a.id = _b.sent();
                        mailBody.status = MailDto_1.MAIL_STATUS.sending;
                        mailBody.sendDatetime = new Date();
                        mailBody.user = MailDto_1.MailDto.receiveAccount;
                        return [4 /*yield*/, mailCollection.insertOne(mailBody)];
                    case 3:
                        _b.sent();
                        i = 0;
                        _b.label = 4;
                    case 4:
                        if (!(i < this.mailAccount.length)) return [3 /*break*/, 9];
                        sender = nodemailer.createTransport(this.mailAccount[i]);
                        mailOptions = {
                            from: "\"" + this.mailAccount[i].name + "\" <" + this.mailAccount[i].address + ">",
                            to: mailBody.user,
                            subject: mailBody.title,
                            text: mailBody.body.substr(0, 100),
                            html: MailDto_1.MailDto.getHtml(mailBody)
                        };
                        mailBody.sender = this.mailAccount[i].address;
                        _b.label = 5;
                    case 5:
                        _b.trys.push([5, 7, , 8]);
                        return [4 /*yield*/, this.sendMail(sender, mailOptions)];
                    case 6:
                        info = _b.sent();
                        logger.log(this.mailAccount[i].name, this.mailAccount[i].address, mailOptions.to, "Message sent: ", info.messageId, mailBody.title);
                        mailBody.status = MailDto_1.MAIL_STATUS.success;
                        mailCollection.updateOne({ id: mailBody.id }, mailBody);
                        return [3 /*break*/, 9];
                    case 7:
                        error_1 = _b.sent();
                        logger.error(this.mailAccount[i].name, this.mailAccount[i].address, mailOptions.to, i, error_1);
                        mailBody.status = MailDto_1.MAIL_STATUS.fail;
                        mailCollection.updateOne({ id: mailBody.id }, mailBody);
                        return [3 /*break*/, 8];
                    case 8:
                        i++;
                        return [3 /*break*/, 4];
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    Mail.getMailList = function (option) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var collection, data;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, MongoDatabase_1.MongoDatabase.getCollection("LarkDB", "Mail")
                        // 1为升序
                    ];
                    case 1:
                        collection = _a.sent();
                        return [4 /*yield*/, collection.find({}).sort({ sendDatetime: -1 }).skip(option.page * option.pageSize).limit(option.pageSize).toArray()];
                    case 2:
                        data = _a.sent();
                        return [2 /*return*/, data];
                }
            });
        });
    };
    Mail.sendMail = function (sender, mailOptions) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        sender.sendMail(mailOptions, function (error, info) {
                            if (error) {
                                reject(error);
                                return;
                            }
                            resolve(info);
                        });
                    })];
            });
        });
    };
    Mail.mailAccount = MailDto_1.MailDto.mailAccount;
    Mail.transporter = null;
    return Mail;
}());
exports.Mail = Mail;
//# sourceMappingURL=Mail.js.map