"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var Controller_1 = require("../../Web/Controller");
var Mail_1 = require("../Mail");
var HttpClient_1 = require("../../Net/HttpClient");
var Application_1 = require("../../Core/Application");
var WebRouter_1 = require("../../Web/WebRouter");
var MailRouter = /** @class */ (function (_super) {
    tslib_1.__extends(MailRouter, _super);
    function MailRouter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MailRouter.prototype.bindRouter = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.router.post("/Notice/Mail/send.json", this.asyncAction.bind(this, MailController, "sendAction"));
                return [2 /*return*/];
            });
        });
    };
    return MailRouter;
}(WebRouter_1.WebRouter));
exports.MailRouter = MailRouter;
var MailController = /** @class */ (function (_super) {
    tslib_1.__extends(MailController, _super);
    function MailController() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * 发送邮件的动作
     * IMailBodyRecord
     */
    MailController.prototype.sendAction = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Mail_1.Mail.send(this.getPost("title"), this.getPost("body"))];
                    case 1:
                        _a.sent();
                        this.sendJSON({ success: true });
                        return [2 /*return*/];
                }
            });
        });
    };
    MailController.send = function (title, body) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var mailBody;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mailBody = {
                            title: title,
                            body: body
                        };
                        return [4 /*yield*/, HttpClient_1.HttpClient.post(Application_1.Application.getLocalServer() + "/Notice/Mail/send.json", mailBody, "json")];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return MailController;
}(Controller_1.Controller));
exports.MailController = MailController;
var MailWebAPI = /** @class */ (function () {
    function MailWebAPI() {
    }
    return MailWebAPI;
}());
//# sourceMappingURL=MailWeb.js.map