"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var fs = require("fs-extra");
var Path = require("path");
var SHA1 = require("sha1");
var LarkError_1 = require("../../Log/LarkError");
var LarkString_1 = require("../../Utils/LarkString");
var FileNameMarker = /** @class */ (function () {
    function FileNameMarker(filename) {
        this.filename = null;
        this.sha1 = null;
        this.setFileName(filename);
    }
    /**
     * 先判断要不要算sha1，
     * 算好sha1
     * 准备开始更换
     */
    FileNameMarker.prototype.rename = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var file, name, lastFileNameField, state, buffer, fileSHA1, filePath;
            return tslib_1.__generator(this, function (_a) {
                file = Path.parse(this.filename);
                name = file.name.split(".");
                lastFileNameField = name.pop();
                // 全小写字母和40的长度判定为sha1
                if (LarkString_1.LarkString.isSHA1(lastFileNameField)) {
                    console.log("跳过计算", this.filename);
                }
                else {
                    name.push(lastFileNameField);
                    state = fs.statSync(this.filename);
                    if (state.isFile()) {
                        if (state.size > 512 * 1024 * 1024) {
                            console.log(new LarkError_1.LarkError("超过可处理的文件大小", { size: state.size }));
                            return [2 /*return*/];
                        }
                        console.log("rename#readFile", this.filename);
                        buffer = fs.readFileSync(this.filename);
                        fileSHA1 = SHA1(buffer);
                        console.log("rename#sha1", fileSHA1);
                        name.push(fileSHA1);
                        filePath = Path.normalize(file.dir + "/" + name.join(".") + file.ext);
                        console.log(filePath);
                        fs.renameSync(this.filename, filePath);
                        this.filename = filePath; // 避免重复调用时，重复计算
                    }
                    else {
                        throw new LarkError_1.LarkError("不是文件");
                    }
                }
                return [2 /*return*/];
            });
        });
    };
    FileNameMarker.prototype.setFileName = function (filename) {
        this.filename = Path.normalize(filename);
        if (fs.existsSync(this.filename) === false) {
            throw new LarkError_1.LarkError("文件不存在", this.filename);
        }
    };
    return FileNameMarker;
}());
exports.FileNameMarker = FileNameMarker;
//# sourceMappingURL=FileNameMarker.js.map