"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var mongodb_1 = require("mongodb");
var UUID = require("uuid");
/**
 * 存在明显性能问题
 */
var MongoDatabase = /** @class */ (function () {
    function MongoDatabase() {
    }
    MongoDatabase.pushTask = function (task) {
        var uuid = UUID();
        this.taskList.set(uuid, task);
        return uuid;
    };
    MongoDatabase.removeTask = function (uuid) {
        this.taskList["delete"](uuid);
    };
    /**
     * 获得数据库对象
     * @param database
     */
    MongoDatabase.getDB = function (databaseName) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var db, url;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        db = this.pool.get(databaseName);
                        url = "mongodb://mongodb.kemao.com/" + databaseName;
                        if (typeof db === "undefined") {
                            console.log("初始化数据库", url);
                            // 推入了一个Promise对象
                            this.pool.set(databaseName, mongodb_1.MongoClient
                                .connect(url, {
                                autoReconnect: true,
                                poolSize: 1
                            }));
                        }
                        return [4 /*yield*/, this.pool.get(databaseName)];
                    case 1:
                        // 等待直到它完成
                        db = _a.sent();
                        db.url = url;
                        return [2 /*return*/, db.db(databaseName)];
                }
            });
        });
    };
    /**
     * 关闭所有队列内的任务
     */
    MongoDatabase.closeAllTaskList = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var keys, _a, value, done;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        keys = this.taskList.keys();
                        _b.label = 1;
                    case 1:
                        if (!true) return [3 /*break*/, 3];
                        _a = keys.next(), value = _a.value, done = _a.done;
                        if (done === true) {
                            // console.log("cleanAllTaskList#success")
                            return [3 /*break*/, 3];
                        }
                        // console.log("cleanTaskList", value)
                        return [4 /*yield*/, this.taskList.get(value)];
                    case 2:
                        // console.log("cleanTaskList", value)
                        _b.sent();
                        return [3 /*break*/, 1];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    /**
    * 关闭队列当中的所有的数据库
    */
    MongoDatabase.close = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var keys, _a, value, done, dbPromise, db;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.closeAllTaskList()];
                    case 1:
                        _b.sent();
                        keys = this.pool.keys();
                        _b.label = 2;
                    case 2:
                        if (!true) return [3 /*break*/, 5];
                        _a = keys.next(), value = _a.value, done = _a.done;
                        if (done === true) {
                            return [3 /*break*/, 5];
                        }
                        dbPromise = this.pool.get(value);
                        this.pool["delete"](value);
                        return [4 /*yield*/, dbPromise];
                    case 3:
                        db = _b.sent();
                        console.log("关闭数据库", value);
                        return [4 /*yield*/, db.close()];
                    case 4:
                        _b.sent();
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 获取一个集合连接
     * @param dbName
     * @param collectionName
     */
    MongoDatabase.getCollection = function (dbName, collectionName) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var db, collection;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getDB(dbName)
                        // console.log("getCollection", { db })
                    ];
                    case 1:
                        db = _a.sent();
                        return [4 /*yield*/, db.collection(collectionName)];
                    case 2:
                        collection = _a.sent();
                        return [2 /*return*/, collection];
                }
            });
        });
    };
    /**
     * 获取一个序列号
     * @param key
     * @param dbName
     * @param sequenceCollectionName
     */
    MongoDatabase.getSequence = function (key, dbName, sequenceCollectionName) {
        if (dbName === void 0) { dbName = "LarkDB"; }
        if (sequenceCollectionName === void 0) { sequenceCollectionName = "Sequence"; }
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var collection, record;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getCollection(dbName, sequenceCollectionName)];
                    case 1:
                        collection = _a.sent();
                        return [4 /*yield*/, collection.findOneAndUpdate({ key: key }, {
                                $inc: {
                                    value: 1
                                },
                                $set: {
                                    updateDatetime: new Date()
                                }
                            }, { upsert: true })];
                    case 2:
                        record = _a.sent();
                        if (record.value === null) {
                            return [2 /*return*/, 0];
                        }
                        return [2 /*return*/, record.value.value];
                }
            });
        });
    };
    MongoDatabase.readStreamBuffer = function (stream) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        var content = [];
                        stream.on("error", function (error) {
                            reject(error);
                        });
                        stream.on("data", function (chunk) {
                            content.push(chunk);
                        });
                        stream.on("end", function () {
                            var buffer = Buffer.concat(content);
                            resolve(buffer);
                        });
                    })];
            });
        });
    };
    MongoDatabase.taskList = new Map();
    MongoDatabase.pool = new Map();
    return MongoDatabase;
}());
exports.MongoDatabase = MongoDatabase;
//# sourceMappingURL=MongoDatabase.js.map