// import * as mysql from "mysql"
// export enum ERROR_MYSQLDATABASE {
//     CONFIG_IS_UNDEFINED = 9000000,
//     /**
//      * 连接失败
//      */
//     CONNECT_FAIL = 9000001,
//     /**
//      * 连接超时
//      */
//     CONNECT_TIMEOUT = 9000002,
//     /**
//      * 没有数据
//      */
//     DATA_IS_NULL = 9000003,
//     /**
//      * 未定义的错误
//      */
//     UNKNOW = 9000004,
// }
// /**
//  * 提供一个单一的数据库访问层。统一对外使用
//  * 支持获取不同的数据库对象,以便操作不同数据库数据
//  */
// export class MysqlDatabase {
//     // private logger = new Logger("MysqlDatabase");
//     // private static instance = {};
//     // private instance: MysqlDatabase = null;
//     private connection = null;
//     public static async getInstance(database: string = "kemao_db"): Promise<MysqlDatabase> {
//         if (typeof MysqlDatabase.instance[database] === "undefined") {
//             MysqlDatabase.instance[database] = new MysqlDatabase();
//             await MysqlDatabase.instance[database].init(database);
//         }
//         return MysqlDatabase.instance[database];
//     }
//     public async init(database: string): Promise<MysqlDatabase> {
//         let config = null;
//         try {
//             config = fs.readJSONSync("./config/db/mysql.json");
//             config = config[database];
//             config.database = database;
//             if (typeof config === "undefined") {
//                 throw new Error(ERROR_MYSQLDATABASE[ERROR_MYSQLDATABASE.CONFIG_IS_UNDEFINED]);
//             }
//         } catch (error) {
//             this.logger.error("init", error);
//             throw new Error(ERROR_MYSQLDATABASE[ERROR_MYSQLDATABASE.CONFIG_IS_UNDEFINED]);
//         }
//         this.logger.log("MysqlDatabase.init", { config });
//         this.connection = mysql.createConnection(config);
//         this.connection.connect();
//         this.connection.config.queryFormat = (query, values) => { return this.queryFormat(query, values); }
//         this.logger.log("MysqlDatabase.init", database, "success");
//         return this;
//     }
//     private queryFormat(query, values) {
//         if (!values) {
//             return query
//         }
//         let rawSql =
//             query.replace(/\:(\w+)/g, (txt, key) => {
//                 if (values.hasOwnProperty(key)) {
//                     return this.escape(values[key]);
//                 }
//                 return txt
//             })
//         const debugSql = query.replace(/\:(\w+)/g, (txt, key) => {
//             if (values.hasOwnProperty(key)) {
//                 if (values[key] instanceof Buffer) {
//                     return "Blob"
//                 }
//                 return this.escape(values[key]);
//             }
//             return txt
//         }).replace(/\r|\n|\t/g, " ").replace(/\s+/g, " ")
//         this.logger.log("MysqlDatabase.queryFormat", { debugSql })
//         return rawSql;
//     }
//     private escape(value) {
//         return this.connection.escape(value)
//     }
//     /**
//      * 传入sql和数据，返回一条数据，如果没有数据，抛出异常
//      * @param sql:string
//      * @param data:any default null
//      * @exception DATABASE_ERROR.DATA_IS_NULL 未找到数据
//      * @exception DATABASE_ERROR.CONNECT_TIMEOUT 数据库连接超时
//      * @exception DATABASE_ERROR.CONNECT_FAIL 数据库连接失败
//      * @exception DATABASE_ERROR.UNKNOW
//      * @return record
//      */
//     public async get(sql: string, data = null) {
//         const results = await this.getList(sql, data);
//         return results[0];
//     }
//     /**
//      * 获取一组数据
//      * @param sql
//      * @param data:any default null
//      * @exception DATABASE_ERROR.DATA_IS_NULL 未找到数据
//      * @exception DATABASE_ERROR.CONNECT_TIMEOUT 数据库连接超时
//      * @exception DATABASE_ERROR.CONNECT_FAIL 数据库连接失败
//      * @exception DATABASE_ERROR.UNKNOW
//      * @return record[]
//      */
//     public async getList(sql: string, data = null) {
//         return new Promise<any>((resolve, reject) => {
//             this.connection.query(sql, data, (error, results, fields) => {
//                 this.logger.log("MysqlDatabase.get", { error, results, fields }, results instanceof Array ? results.length : null);
//                 if (error === null) {
//                     if (results.length > 0 && results instanceof Array) {
//                         this.logger.log("MysqlDatabase.get.resolve", results)
//                         resolve(results)
//                     } else {
//                         const err = new Error(ERROR_MYSQLDATABASE[ERROR_MYSQLDATABASE.DATA_IS_NULL])
//                         err.name = ERROR_MYSQLDATABASE[ERROR_MYSQLDATABASE.DATA_IS_NULL];
//                         err.data = results;
//                         reject(err);
//                     }
//                 } else {
//                     error.name = ERROR_MYSQLDATABASE.UNKNOW;
//                     reject(error)
//                 }
//             })
//         });
//     }
//     /**
//      * 插入数据
//      * @param sql
//      * @param data
//      * @return void
//      */
//     public async insert(sql: string, data) {
//         await this.query(sql, data);
//     }
//     /**
//      * 更新数据
//      * @param sql
//      * @param data
//      */
//     public async update(sql: string, data) {
//         try {
//             await this.query(sql, data);
//         } catch (error) {
//             // todo: 如果自动插入为true，并且错误类型为更新记录数为0，则自动插入它，并报告为更新成功非异常
//             throw error;
//         }
//     }
//     public async close() {
//         MysqlDatabase.instance = null;
//         this.connection.end();
//     }
//     private async query(sql: string, data) {
//         // this.logger.log("MysqlDatabase.query", { sql, data });
//         return new Promise<any>((resolve, reject) => {
//             this.connection.query(sql, data, (error, results, fields) => {
//                 // this.logger.log("Database.query", { error, results, fields })
//                 if (error === null) {
//                     resolve({ results, fields });
//                 } else {
//                     error.name = ERROR_MYSQLDATABASE.UNKNOW;
//                     reject(error)
//                 }
//             });
//         });
//     }
// }
//# sourceMappingURL=MysqlDatabase.js.map