import { WEEK, ILarkDate } from './LarkDate/LarkDateDto';
export declare class LarkDate {
    /**
     * 获得星期
     * @param date 时间
     */
    static getWeekStringByDate(date: Date): "星期天" | "星期一" | "星期二" | "星期三" | "星期四" | "星期五" | "星期六";
    static getWeekString(week: WEEK): "星期天" | "星期一" | "星期二" | "星期三" | "星期四" | "星期五" | "星期六";
    /**
     * 实例化一个时间对象，传什么得什么
     * @param date 时间
     */
    static getDate(date: ILarkDate): Date;
    /**
     * 时间格式化
     * @param Date date
     * @param format "yyyy-MM-dd hh:mm:ss.uuu"
     * @return string date
     */
    static format(date: Date, format?: string): string;
    /**
     * @param Date date
     * @return string  "yyyy-MM-dd hh:mm:ss.uuu"
     * @deprecated 过时了，直接使用format
     */
    static getDateTimeString(date: Date): string;
    /**
     * 获得字符串的时间，不带任何符号。数字类型
     * @param Date date
     * @return number "yyyyMMddhhmmssuuu"
     */
    static getDateTimeStringNumber(date: Date): number;
    static getDateString(date: any): string;
    static getDateStringNumber(date: any): number;
    /**
     * 代码延迟执行
     * @param timeout 延时时间
     */
    static delay(timeout: number): Promise<{}>;
    /**
     * 代码延迟区间执行
     * @param min 最小值
     * @param max 最大值
     */
    static delayRange(min: number, max: number, callback?: (timeout) => Promise<void>): Promise<void>;
    static tideInterval(): Promise<void>;
}
