"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var Controller_1 = require("../../Web/Controller");
var MongoDatabase_1 = require("../../Storage/MongoDatabase/MongoDatabase");
var LarkDate_1 = require("../LarkDate");
var WebRouter_1 = require("../../Web/WebRouter");
var Application_1 = require("../../Core/Application");
var HttpClient_1 = require("../../Net/HttpClient");
var LarkLogger_1 = require("../../Log/Logger/LarkLogger");
var logger = new LarkLogger_1.LarkLogger("Utils/LarkSequence/LarkSequnenceWeb");
/**
 * Web就是 Controller/LarkRouter/LarkSequenceWebAPI 一体
 */
var LarkSequenceController = /** @class */ (function (_super) {
    tslib_1.__extends(LarkSequenceController, _super);
    function LarkSequenceController() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LarkSequenceController.prototype.getNPMSequenceAction = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var packageName, value, info;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        packageName = this.getQuery("packageName");
                        return [4 /*yield*/, MongoDatabase_1.MongoDatabase.getSequence(packageName, "LarkDB", "NPMSequence")];
                    case 1:
                        value = _a.sent();
                        info = {
                            ok: true,
                            key: packageName,
                            value: value,
                            datetime: LarkDate_1.LarkDate.format(new Date())
                        };
                        // logger.log("LarkSequenceController.getNPMSequence", info)
                        this.sendJSON(info);
                        return [2 /*return*/];
                }
            });
        });
    };
    return LarkSequenceController;
}(Controller_1.Controller));
exports.LarkSequenceController = LarkSequenceController;
var LarkSequenceRouter = /** @class */ (function (_super) {
    tslib_1.__extends(LarkSequenceRouter, _super);
    function LarkSequenceRouter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LarkSequenceRouter.prototype.bindRouter = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                this.router.get("/Utils/LarkSequence/NPMSequence.json", this.asyncAction.bind(this, LarkSequenceController, "getNPMSequenceAction"));
                return [2 /*return*/];
            });
        });
    };
    return LarkSequenceRouter;
}(WebRouter_1.WebRouter));
exports.LarkSequenceRouter = LarkSequenceRouter;
/**
 * 这里的方法都是通过WebAPI进行通信
 */
var LarkSequenceWebAPI = /** @class */ (function () {
    function LarkSequenceWebAPI() {
    }
    /**
     * 走中心服务器，通过http获取发号器序号
     * @param packageName
     */
    LarkSequenceWebAPI.getNPMSequence = function (packageName) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var url, response;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = Application_1.Application.getLarkServer() + ("/Utils/LarkSequence/NPMSequence.json?packageName=" + encodeURIComponent(packageName));
                        return [4 /*yield*/, HttpClient_1.HttpClient.getJSON(url)
                            // logger.log(response)
                        ];
                    case 1:
                        response = _a.sent();
                        // logger.log(response)
                        return [2 /*return*/, response.value];
                }
            });
        });
    };
    /**
     * 这个是调用远程获取数据
     * @param packageName
     */
    LarkSequenceWebAPI.getNPMSequenceByLocal = function (packageName) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var url, response;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = Application_1.Application.getLocalServer() + ("/Utils/LarkSequence/NPMSequence.json?packageName=" + encodeURIComponent(packageName));
                        return [4 /*yield*/, HttpClient_1.HttpClient.getJSON(url)];
                    case 1:
                        response = _a.sent();
                        logger.log(response);
                        return [2 /*return*/, response.value];
                }
            });
        });
    };
    return LarkSequenceWebAPI;
}());
exports.LarkSequenceWebAPI = LarkSequenceWebAPI;
//# sourceMappingURL=LarkSequenceWeb.js.map