"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var Express = require("express");
var Lodash = require("lodash");
var ErrorController_1 = require("./Controller/ErrorController");
//
/**
 * 主要功能，Router
 * 具有超时机制，以及异常管理，同时还能
 */
var WebRouter = /** @class */ (function () {
    function WebRouter() {
        this.router = Express.Router();
        this.logger = console;
    }
    WebRouter.prototype.getRouter = function () {
        this.bindRouter();
        return this.router;
    };
    /**
     * 用于注册Router
     */
    WebRouter.prototype.bindRouter = function () {
        console.info("未重载setRouter方法");
    };
    /**
     * 重载该方法可以管理单个路由对异常的行为
     * @param error
     * @param request
     * @param response
     * @param next
     */
    WebRouter.prototype.asyncActionErrorHandler = function (error, request, response, next) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(error !== null)) return [3 /*break*/, 2];
                        return [4 /*yield*/, new ErrorController_1.ErrorController(request, response, next).errorAction(error)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    WebRouter.prototype.asyncAction = function (controller, action, request, response, next) {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var ctr, error_1;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (Lodash.includes(Object.keys(controller.prototype), action) === false) {
                            this.logger.error({ action: action });
                            return [2 /*return*/, next(new Error("CONTROLLER_ACTION_IS_NOT_FOUND"))];
                        }
                        return [4 /*yield*/, new controller(request, response, next)];
                    case 1:
                        ctr = _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 6]);
                        return [4 /*yield*/, ctr[action]()];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 6];
                    case 4:
                        error_1 = _a.sent();
                        console.error("Router.asyncAction", error_1);
                        // 捕获到错误之后，将错误交给下游的中间件处理，下游中间件决定输出错误到页面还是继续处理。输出json还是输出html页面
                        return [4 /*yield*/, this.asyncActionErrorHandler(error_1, request, response, next)];
                    case 5:
                        // 捕获到错误之后，将错误交给下游的中间件处理，下游中间件决定输出错误到页面还是继续处理。输出json还是输出html页面
                        _a.sent();
                        return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    return WebRouter;
}());
exports.WebRouter = WebRouter;
//# sourceMappingURL=WebRouter.js.map